using System.Collections;
using Upsilon.Evaluator;
using Upsilon.Text;

namespace Upsilon.BaseTypes.ScriptFunction
{
    public abstract class ScriptFunction : ScriptType
    {
        public string Name { get; protected set; }

        protected ScriptFunction(string name, bool isCoroutine)
        {
            Name = name;
            IsCoroutine = isCoroutine;
        }

        public override TypeContainer Type => BaseTypes.Type.Function;
        public override object ToCSharpObject()
        {
            return this;
        }

        public override System.Type GetCSharpType()
        {
            return null;
        }

        public bool IsCoroutine { get; }

        public abstract ScriptType Run(Diagnostics diagnostics, ScriptType[] variables, EvaluationScope scope, TextSpan span, EvaluationState state);
        public abstract IEnumerator RunCoroutine(Diagnostics diagnostics, ScriptType[] variables, EvaluationScope scope, TextSpan span, EvaluationState state);
    }
}