using System;
using System.Collections.Generic;
using Upsilon.BaseTypes;
using Upsilon.Evaluator;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundBadExpression : BoundExpression
    {
        public BoundBadExpression(TextSpan span) : base(span)
        {
        }

        public override BoundKind Kind => BoundKind.BoundBadExpression;

        public override IEnumerable<BoundNode> GetChildren()
        {
            yield break;
        }

        public override TypeContainer ValueType => BaseTypes.Type.Nil;
        internal override ScriptType Evaluate(EvaluationScope scope, Diagnostics diagnostics, ref EvaluationState state)
        {
            throw new Exception("Can't evaluate bad syntax.");
        }
    }
}