using System;
using System.Collections.Generic;
using Upsilon.BaseTypes;
using Upsilon.Evaluator;
using Upsilon.Exceptions;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundVariableExpression : BoundExpression
    {
        public BoundVariableExpression(BoundVariableSymbol variable, TextSpan span) : base(span)
        {
            Variable = variable;
        }

        public BoundVariableSymbol Variable { get; }
        public override BoundKind Kind => BoundKind.VariableExpression;

        public override IEnumerable<BoundNode> GetChildren()
        {
            yield break;
        }

        public override TypeContainer      ValueType => Variable.ValueType;
        internal override ScriptType Evaluate(EvaluationScope scope, Diagnostics diagnostics, ref EvaluationState state)
        {
            return Variable.Evaluate(scope, diagnostics, ref state);
        }
    }
}