using System.Collections.Generic;

namespace Upsilon.Parser
{
    public class YieldStatementSyntax : StatementSyntax
    {
        public SyntaxToken YieldToken { get; }
        public ExpressionSyntax Expression { get; }

        public YieldStatementSyntax(SyntaxToken yieldToken, ExpressionSyntax expression)
        {
            YieldToken = yieldToken;
            Expression = expression;
        }

        public override SyntaxKind Kind => SyntaxKind.YieldStatement;
        public override IEnumerable<SyntaxNode> ChildNodes()
        {
            yield return YieldToken;
            yield return Expression;
        }
    }
}